/*
    Zamykanie systemu, jeli nie ma napicia w sieci :)
    
    Program ma sens istnienia tylko przy wsppracy komputera z UPS.

    Z gniazdka (przez zasilacz) podajemy napicie np. +5V na przekanik,
    ktrym zwieramy jeden z pinw LPT (11, 12, 13) do masy.
    Moecie wybra 2 skrajne piny 13 (SelectIn) oraz 25 (masa).
    
    Jeeli napicia nie bdzie przez kolejne 6 odczytw z portu, to
    komputer zrobi halt :) (standardowo po okolo minucie, ale czas mona
    wyduy, zmieniajc #define TIMER 6 na inna warto. Przy czym 1 = 10s
    2 = 20s itd).

    Program steruje rwnie diod wiecc, ktr mona przylutowa
    do ktregokolwiek z pinw od 2 do 9 portu LPT poprzez rezystor.
    Dla czerwonej LED rezystor 2.3k Ohm.

    Jeeli nie bdzie napicia w czasie odczytu to LED zawieci si na
    sekund i zganie.

    jolach@kwant.info
    http://www.kwant.info

*/

#include <sys/io.h>
#include <stdio.h>

#define TIMER	6
#define D1	0xff
#define PORT	0x378
#define PORT2	0x379
#define ZGAS	outb(0, PORT)
#define WLACZ	outb(D1, PORT)
#define WAIT	sleep(10)

void halt ( void )
{
    printf("Zamykam system!\n");
    ZGAS;
    system("halt");
    exit(0);
}

int main ( void )
{
    int b,s;
    char a[4];
    int timer = 0;

    iopl(3);
    
    /* wylacz LED */
    ZGAS;

    printf("\n\nPodlacz zasilacz z przekaznikiem do portu LPT.\n");
    printf("Sledzik zapamieta ustawienia portu i jesli zmienia sie one (braknie zasilania) to sledz wykryje to\n");
    printf("No to podlaczaj zasilacz :) Juz? (y)");

    scanf("%1s", &a);
    s = inb( PORT2 );
    printf("\nOdczyt z portu |%d|\nJezeli stan ten ulegnie zmianie, oznaczac to bedzie, ze cos majstrujesz przy zasilaniu :)\nZaczynam sledzenie.\n\n", s);
    
    while(1)
    {
	/* odczyt z portu */
	b = inb( PORT2 );

	/* nie ma napiecia na wejsciu */
	if( b != s )
	{
	    printf("[%d/%d]: NIE MA NAPIECIA NA LPT! (stan = %d)\n", timer+1, TIMER, b );
	    WLACZ;
	    sleep(1);
	    ZGAS;
	    if( timer < TIMER )
		timer++;
	}
	else
	    {
	    timer = 0;
	    printf("OK (stan = %d)\n", b);
	    }

	/* po 6 * 10s wylaczam komputer */
	if( timer >= TIMER )
	{
	    timer = 0;
	    halt();
	}
	
	/* co 10s test */
    	WAIT;
    }

}
